import numpy as np

class BinaryLDA:
  """
	Binary Linear Discriminant Analysis (LDA) classifier for classification,
	where the labels are encoded as 0s and 1s
  """
  def __init__(self):
    self.w = None
    self.t = None
	
  def get_covariance_matrix(self, X):
    """
    Calculate the covariance matrix for the dataset X
    """
    # It is recommended that you try to compute the covariance matrix
    # by performing the needed operations by hand, instead of using np.cov()
    # function, this way you will have better idea of the covariance matrix

    # Also take into account that the random variables for which you want to 
    # compute the covariance matrix are the columns of X, not the rows!

    # YOUR CODE HERE
    return covariance_matrix

  def fit(self, X, y):
      # Separate data by class for convenience
      X1 = X[y == 0]
      X2 = X[y == 1]

      # Calculate the covariance matrices of the two datasets
      cov1 = self.get_covariance_matrix(X1)
      cov2 = self.get_covariance_matrix(X2)
      
      # cov1 and cov2 should already be normalized,
      # therefore we just add them to get sigma (from our lecture slides)
      sigma = cov1 + cov2   

      # Calculate the mean of the two datasets (mu_k in our lecture slides)
      mean1 = # YOUR CODE HERE
      mean2 = # YOUR CODE HERE
      mean_diff = mean1 - mean2
      mean_sum = mean1 + mean2

      # Calculate the class priors
      p1 = # YOUR CODE HERE
      p2 = # YOUR CODE HERE

      # Get the inverse of sigma
      sigma_inv = # YOUR CODE HERE

      # determine the decision boundary w*x=t
      # using the formula from the lecture slides
      # you need to figure out which terms form 'w' and 
      # which form 't'
      self.w = # YOUR CODE HERE 
      self.t = # YOUR CODE HERE  

  def predict(self, X):
      # use self.w and self.t to make the predictions for 
      # each instance in X 
      # (after writing the code with a loop, try to do the same with one line) 
      y_pred = # YOUR CODE HERE
      return y_pred

class LDA:
  """
	Linear Discriminant Analysis (LDA) classifier 
  for multiclass classification with arbitrary label encoding
  """
  def __init__(self):
    # YOUR CODE HERE
	
  def get_covariance_matrix(self, X):
    """Calculate the covariance matrix for the dataset X """
    # It is recommended that you try to compute the covariance matrix
    # by performing the needed operations by hand, instead of using np.cov()
    # function, this way you will have better idea of the covariance matrix

    # Also take into account that the random variables for which you want to 
    # compute the covariance matrix are the columns of X, not the rows!

    # don't forget the 1/(N-K) term in this case
    # YOUR CODE HERE
    return covariance_matrix

  def fit(self, X, y):
    # compute means (mu_k), priors (p_k) for each class and
    # sigma by adding the class covariance matrices 
    
    # YOUR CODE HERE

    # get the inverse of sigma
    sigma_inv = # YOUR CODE HERE

    # remember that we need to compute the values of the 
    # discriminant functions (deltas) for each class, so we will need
    # the respective coefficients to use in the 'predict' method
    
    # you can store those coefficients in some data structure   
    self.deltas = # YOUR CODE HERE

  def predict(self, X):
    # use the coefficients in self.deltas to compute delta_k per class
    # for each instance from X and select the class 
    # which has the highest delta_k
    return y_pred


class QDA:
  """
	Quadratic Discriminant Analysis (QDA) classifier 
  for multiclass classification with arbitrary label encoding
  """
  def __init__(self):
    # YOUR CODE HERE
	
  def get_covariance_matrix(self, X):
    """ Calculate the covariance matrix for the dataset X """    
    # what should be instead of K in this term 1/(N-K) in this case ?!
    # YOUR CODE HERE
    return covariance_matrix

  def fit(self, X, y):

    # compute means (mu_k), priors (p_k) and sigma_k for each class
    # you will also need the determinant and inverse of each sigma_k 
    
    # YOUR CODE HERE

    # remember that we need to compute the values of the 
    # discriminant functions (deltas) for each class, so we will need
    # the respective coefficients to use in the 'predict' method
    
    # you can store those coefficients in some data structure   
    self.deltas = # YOUR CODE HERE
    
    self.delta = delta

  def predict(self, X):
    # use the coefficients in self.deltas to compute delta_k per class
    # for each instance from X and select the class 
    # which has the highest delta_k
    return y_pred



